

/****************************************************************/
/* angles.c								                        */
/*                                                              */
/* HPGL labels printing in 30 degree increments 				*/
/*	(centered, LO12)											*/
/*                                                              */
/* Date : 9-29-89				          					    */
/****************************************************************/

#define PI 3.14159

#include <math.h>
#include <stdio.h>
#include <fcntl.h>

int description();

FILE *prn;

main()

{ /* beginning of main program */


/* initialization section */

int i;
float coss, sinn, angle;
prn = fopen("PRN","wb");

/* portrait printout */

fprintf(prn,"\33E");        	/* send an esc E to reset printer */

fprintf(prn,"\33&l0E");			/* set top margin to 0 */

fprintf(prn,"\33%1B");  		/* enter HPGL mode at current PCL position */

fprintf(prn,"IN"            	/* initialize HPGL */
			"SC0,100,0,100" 	/* Scale 100 X 100 */
			"SP1PA0,0");		/*  Select Pen 1, Plot Absolute 0,0 */

fprintf(prn,"DT~,1");			/* define label terminator,~ and don't print */


for (i=0;i<12;i++)
	{
	fprintf(prn,"PU50,50");     /* Pen Up 50,50 */

	angle = i * PI/6;			/* setup 30 degree angles */

	coss = cos(angle);

	sinn = sin(angle);

	fprintf (prn,"DI%f %f"
		,coss,sinn);			/* Label Direction */

	fprintf(prn,"LO12"			/* label origin */
				"SI1.25,1.25"	/* absolute char. size */
				"AD1,0,2,1,"	/* character set, spacing */
				"4,10,5,1,"     /* height, posture */
				"6,0,7,5"		/* weight, typeface */
				"SALB  Angles~"); /* select alternate font, Label Command */
	}

fprintf(prn,"PU50,50;");		/* Pen Up 50,50 */

fprintf(prn,"\33%0A");  		/* enter PCL mode at previous CAP */

fprintf(prn,"\33*p3000Y");		/* absolute cursor position 10 inches */

description();

fprintf(prn,"\f");				/* formfeed */

}	/* End of the Main Program */


description()
{

fprintf(prn,"\33(s1p12v1s0b4101T");		/* select 12 pt CG Times Italic */

fprintf(prn,"HP-GL/2 Labels, "
			"angled in 30 degree "
			"increments.\n\rThe "
			"HP-GL/2 Labels are "
			"accessed from the "
			"internally resident "
			"CG Times Italic typeface.");
}