/****************************************************************/
/* conglom6.c	(univers, light)		                        */
/*                                                              */
/* HPGL labels printing in 1cm mirrored images (slanted 20 deg)	*/
/*          									                */
/* Date : 10-7-89				          					    */
/****************************************************************/

#define  PI 3.14159
#define  XIN    4.75
#define	 YIN	4.75
#define  FACTOR  1

#include <math.h>
#include <stdio.h>
#include <fcntl.h>

int description(), mirror(), north(), scale(), degrees,
	patterns(), reverse(), shadow(), angles(), pies();

FILE *prn;

main()

{ /* beginning of main program */

/* initialization section */

prn = fopen("PRN","wb");

/* portrait printout */

fprintf(prn,"\33E");         			/* send an esc E to reset printer */

fprintf(prn,"\33&l0E");					/* select top margin */

mirror();

scale();

north();

reverse();

patterns();

shadow();

angles();

pies();

fprintf(prn,"\33*p3000Y");				/* vertical cursor position */

fprintf(prn,"\f");						/* formfeed */

}    /* Ending of the Main Program */

description()
{
fprintf(prn,"\33(s1p12v1s0b4101T");		/* select 60 pt CG Times Italic */

fprintf(prn,"descriptive text maybe?\n\r");
}

mirror()
{
float size;
float xsize, ysize, decipoint = 720;
float coss, sinn, angle;

/* set up hpgl picture frame */

xsize = (8.5)*decipoint/FACTOR;
ysize = (11)*decipoint/FACTOR;

fprintf(prn,"\33*c%fx%fY"
			,xsize,ysize);		 	 	/* set pict. frame dimensions in decipnts */

fprintf(prn,"\33*c0T");  		 		/* enter picture frame anchor point */

										/*	plot size commands do not affect
										the picture frame scaling if not
										using plotter units (i.e. SC)	 */

/* enter hpgl mode */

fprintf(prn,"\33%1B");  				/* enter HPGL mode at current PCL position */

fprintf(prn,"INIW"               			/* initialize HP-GL/2 */
			"SC0,100,0,100"             /* SCALE 100 X 100 */
			"SP1PA0,0");				/* Select Pen 1, Plot Absolute 0,0 */

fprintf(prn,"DT~,1");					/* define label terminator,~ and don't print */

fprintf(prn,"PU58,91.5");					/* pen up 15,60 */

fprintf(prn,"SI1.25,1.7"					/* label origin, absolute char. size */
			"AD1,0,2,1,"				/* symbol set, spacing */
			"4,10,5,1,"     			/* height, posture */
			"6,0,7,5"					/* weight, typeface */
			"SALBMirror~"); 			/* select alternate font, Label Command */

fprintf(prn,"PU58,91");					/* pen up 15,50 */

fprintf(prn,"CF3,1");					/* character fill & edge */

fprintf(prn,"FT10,20");					/* fill type, PCL pattern, # */

fprintf(prn,"SI1.25,-1.7"					/* absolute char. size */
			"LBMirror~;"); 				/* Label Command */

fprintf(prn,"PU4,74");					/* pen up 15,60 */

fprintf(prn,"CF1");						/* character no fill & edge */

fprintf(prn,"FT10,20");					/* fill type, shading, % */

fprintf(prn,"SI1.2,2"					/* label origin, absolute char. size */
			"AD1,0,2,1,"				/* symbol set, spacing */
			"4,60,5,1,"     			/* height, posture */
			"6,0,7,5"					/* weight, typeface */
			"SALBType~;"); 				/* select alternate font, Label Command */

fprintf(prn,"\33%0A");  				/* enter PCL mode at previous CAP */
}


scale()
{
/* fprintf(prn,"\33&*p300x600Y");					/* 581 cursor position */

fprintf(prn,"\33&a90h1360V");					/* 581 cursor position */


fprintf(prn,"\33(8U");

fprintf(prn,"\33(s1p"
			"50v0s3b"
			"4101T");					/* font select by attribute */

fprintf(prn,"S");

fprintf(prn,"\33(s75V");

fprintf(prn,"C");

fprintf(prn,"\33(s95V");

fprintf(prn,"A");

fprintf(prn,"\33(s120V");

fprintf(prn,"L");

fprintf(prn,"\33(s158V");

fprintf(prn,"E");
}


north()
{
/* fprintf(prn,"\33&*p300x600Y");					/* 581 cursor position */

fprintf(prn,"\33&a4050h1810V");					/* 581 cursor position */


fprintf(prn,"\33(8U");

fprintf(prn,"\33(s1p"
			"45v0s0b"
			"4101T");					/* font select by attribute */

fprintf(prn,"NORTH\10");

degrees=270;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

fprintf(prn,"  EAST\10\33=");

degrees=180;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

fprintf(prn,"SOUTH\10");

degrees=90;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

fprintf(prn," WEST");

degrees=0;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

fprintf(prn,"\33&a4300h2080V");					/* 581 cursor position */

fprintf(prn,"\33(8U");

fprintf(prn,"\33(s1p"
			"27v0s0b"
			"4101T");					/* font select by attribute */

fprintf(prn,"NORTH\10");

degrees=270;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

fprintf(prn,"  EAST\10\33=");

degrees=180;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

fprintf(prn,"SOUTH\10");

degrees=90;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

fprintf(prn," WEST");

degrees=0;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

fprintf(prn,"\33&a4480h2260V");					/* 581 cursor position */

fprintf(prn,"\33(8U");

fprintf(prn,"\33(s1p"
			"15v0s0b"
			"4101T");					/* font select by attribute */

fprintf(prn,"NORTH\10");

degrees=270;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

fprintf(prn,"  EAST\10\33=");

degrees=180;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

fprintf(prn,"SOUTH\10");

degrees=90;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

fprintf(prn," WEST");

degrees=0;

fprintf(prn,"\33&a%dP",degrees);       	/* specify deg rotation print direction */

}

reverse()
{
int degres;

fprintf(prn,"\33&a90h2520V");  				/* set cursor position for rule */

fprintf(prn,"\33*c488a2100B");  			/* set rule size in dots */

fprintf(prn,"\33*c0P");  					/* print rule */

fprintf(prn,"\33&a1150h7240V");  			/* set cursor position for text */

degres=90;

fprintf(prn,"\33&a%dP",degres);       	/* specify deg rotation print direction */

fprintf(prn,"\33*v0n1O");					/* source = transp, pattern = opaque */

fprintf(prn,"\33(s1p140v1s3b5T");			/* font select by attribute */

fprintf(prn,"\33*v1T");						/* select HP shading pattern */

fprintf(prn,"Reverse");

degres = 0;

fprintf(prn,"\33&a%dP",degres);
}

patterns()
{
int point_size=93;

fprintf(prn,"\33&a1480h7560V");  			/* set 1300 cursor position */

fprintf(prn,"\33(s1p%dv0s3b4148T"
			,point_size);  					/* font select by attribute */

fprintf(prn,"\33*c1G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select solid white pattern */

fprintf(prn,"P");

fprintf(prn,"\33*c2G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select HP pattern */

fprintf(prn,"\33&a-90H");  			/* set 1300 cursor position */

fprintf(prn,"A");

fprintf(prn,"\33*c3G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select HP pattern */

fprintf(prn,"\33&a-90H");  			/* set 1300 cursor position */

fprintf(prn,"T");

fprintf(prn,"\33*c3G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select HP pattern */

fprintf(prn,"T");

fprintf(prn,"\33*c4G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select HP pattern */

fprintf(prn,"E");

fprintf(prn,"\33*c5G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select HP pattern */

fprintf(prn,"R");

fprintf(prn,"\33*c6G");						/* select % shading */

fprintf(prn,"\33*v3T");						/* select HP shading pattern */

fprintf(prn,"N");
}

shadow()
{
int degris;
int point_size=95, i,
	shading, count=1, xoffset, yoffset;

fprintf(prn,"\33*v0n1O");					/* source = transp, pattern = opaque */

for (i=0;i<100;i=i+5)
	{
	/* shaded print */

    degris = 0;

    fprintf(prn,"\33&a%dP",degris);

	fprintf(prn,"\33&a2260h6200V");  		/* set cursor position */

	count++;

	xoffset=count*5;

	yoffset=count*10;

	shading=100-i;

	fprintf(prn,"\33*p+%dY",yoffset);  		/* set cursor position */

	fprintf(prn,"\33*p-%dX",xoffset);  		/* set cursor position */

	fprintf(prn,"\33*c%dG",shading);		/* select % shading */

	fprintf(prn,"\33*v2T");					/* select HP shading pattern */

	fprintf(prn,"\33(s1p%dv1s3b5T"
				,point_size);  				/* font select by attribute */

	degris=90;

	fprintf(prn,"\33&a%dP",degris);       	/* specify deg rotation print direction */

    fprintf(prn,"Shadow");

	}

degris = 0;

fprintf(prn,"\33&a%dP",degris);

	fprintf(prn,"\33&a2260h6200V");  		/* set cursor position */

	fprintf(prn,"\33*p+210Y");  		/* set cursor position */

	fprintf(prn,"\33*p-105X");  		/* set cursor position */

	fprintf(prn,"\33*v1T");					/* select HP shading pattern */

	fprintf(prn,"\33(s1p%dv1s3b5T"
				,point_size);  				/* font select by attribute */

	degris=90;

	fprintf(prn,"\33&a%dP",degris);       	/* specify deg rotation print direction */

    fprintf(prn,"Shadow");

degris = 0;

fprintf(prn,"\33&a%dP",degris);



}


angles()
{

float size;
float xsize, ysize, decipoint = 720;

int i;
float coss, sinn, angle;

fprintf(prn,"\33&a2310h3445V");

/* set up hpgl picture frame */

xsize = (XIN)*decipoint/FACTOR;
ysize = (YIN)*decipoint/FACTOR;

fprintf(prn,"\33*c%fx%fY"
			,xsize,ysize);		 	 	/* set pict. frame dimensions in decipnts */

fprintf(prn,"\33*c0T");  		 		/* enter picture frame anchor point */

										/*	plot size commands do not affect
										the picture frame scaling if not
										using plotter units (i.e. SC)	 */

/* enter hpgl mode */

fprintf(prn,"\33%1B");  		/* enter HPGL mode at current PCL position */

fprintf(prn,"IN"            	/* initialize HPGL */
			"SC0,100,0,100" 	/* Scale 100 X 100 */
			"SP1PA0,0");		/*  Select Pen 1, Plot Absolute 0,0 */

fprintf(prn,"DT~,1");			/* define label terminator,~ and don't print */

for (i=0;i<12;i++)
	{
	fprintf(prn,"PU50,50");     /* Pen Up 50,50 */

	angle = i * PI/6;			/* setup 30 degree angles */

	coss = cos(angle);

	sinn = sin(angle);

	fprintf (prn,"DI%f %f"
		,coss,sinn);			/* Label Direction */

	fprintf(prn,"LO12"			/* label origin */
				"SR6.5,6.5"	/* absolute char. size */
				"AD1,0,2,1,"	/* character set, spacing */
				"4,10,5,1,"     /* height, posture */
				"6,1,7,5"		/* weight, typeface */
				"SALB  Angles~"); /* select alternate font, Label Command */
	}
fprintf(prn,"\33%0A");  		/* enter PCL mode at previous CAP */
}


pies()
{

float size;

float xsize, ysize, decipoint = 720;

fprintf(prn,"\33&a800h670V");

/* set up hpgl picture frame */

xsize = (XIN)*decipoint/FACTOR;
ysize = (YIN)*decipoint/FACTOR;

fprintf(prn,"\33*c%fx%fY"
			,xsize,ysize);		 	 	/* set pict. frame dimensions in decipnts */

fprintf(prn,"\33*c0T");  		 		/* enter picture frame anchor point */

										/*	plot size commands do not affect
										the picture frame scaling if not
										using plotter units (i.e. SC)	 */

/* enter hpgl mode */

fprintf(prn,"\33%1B");  				/* enter HPGL mode at current PCL position */

fprintf(prn,"IN"
			"SC0,100,0,100SP1PA0,0");	/* SCALE 100 X 100, MOVE PEN TO 0,0 */

fprintf(prn,"DT~,1");					/* define label terminator,~ and don't print */

fprintf(prn,"LO12"						/* label origin */
			"AD1,0,2,1,"				/* symbol set, proportional spacing */
			"4,13.5,5,0,"     			/* height, posture */
			"6,3,7,4148"					/* weight, typeface */
			"SA");						/* select alternate font */

fprintf(prn,"PU50,50");					/* position pen */

fprintf(prn,"FT10,30");					/* fill type, shading % */

fprintf(prn,"WG25,0,90EW25,0,90");				/* fill wedge, edge polygon */

fprintf(prn,"FT10,20");					/* fill type, shading % */

fprintf(prn,"WG25,90,90EW25,90,90");				/* fill wedge, edge polygon */

fprintf(prn,"FT10,10");					/* fill type, shading % */

fprintf(prn,"WG25,180,90EW25,180,90");				/* fill wedge, edge polygon */

fprintf(prn,"PU53,42");					/* position pen */

fprintf(prn,"FT10,60");					/* fill type, shading % */

fprintf(prn,"WG25,270,45EW25,270,45");				/* fill wedge, edge polygon */

fprintf(prn,"PU51,49");					/* position pen */

fprintf(prn,"FT10,40");					/* fill type, shading % */

fprintf(prn,"WG25,315,45EW25,315,45");				/* fill wedge, edge polygon */

fprintf(prn,"PU56,63");             	/* position pen for label */

fprintf(prn,"LB 30%~");					/* label */

fprintf(prn,"CPLBGray~");				/* label */

fprintf(prn,"PU33.5,63");             	/* position pen for label */

fprintf(prn,"LB 20%~");					/* label */

fprintf(prn,"CPLBGray~");				/* label */

fprintf(prn,"PU33.5,43");             	/* position pen for label */

fprintf(prn,"LB 10%~");					/* label */

fprintf(prn,"CPLBGray~");				/* label */

fprintf(prn,"PU53.5,29");             	/* position pen for label */

fprintf(prn,"LB 60%~");					/* label */

fprintf(prn,"CPLBGray~");				/* label */

fprintf(prn,"PU62.5,45");             	/* position pen for label */

fprintf(prn,"LB 40%~");					/* label */

fprintf(prn,"CPLBGray~");				/* label */

fprintf(prn,"\33%0A");  				/* enter PCL mode at previous CAP */

}