
/****************************************************************/
/* mirror.c								                        */
/*                                                              */
/* HPGL labels printing in 1cm mirrored images (slanted 20 deg)	*/
/*          									                */
/* Date : 8-7-89				          					    */
/****************************************************************/

#include <stdio.h>
#include <fcntl.h>

int description();

FILE *prn;

main()

{ /* beginning of main program */

/* initialization section */

prn = fopen("PRN","wb");

/* portrait printout */

fprintf(prn,"\33E");         			/* send an esc E to reset printer */

fprintf(prn,"\33&l0E");					/* select top margin */

fprintf(prn,"\33%1B");  				/* enter HPGL mode at current PCL position */

fprintf(prn,"IN"               			/* initialize HP-GL/2 */
			"SC0,100,0,100"             /* SCALE 100 X 100 */
			"SP1PA0,0");				/* Select Pen 1, Plot Absolute 0,0 */

fprintf(prn,"DT~,1");					/* define label terminator,~ and don't print */

fprintf(prn,"PU15,60");					/* pen up 15,60 */

fprintf(prn,"LO12SI2,2"					/* label origin, absolute char. size */
			"AD1,0,2,1,"				/* symbol set, spacing */
			"4,10,5,1,"     			/* height, posture */
			"6,0,7,5"					/* weight, typeface */
			"SL0.364"					/* character slant (tan20=0.36) */
			"SALBMirror~"); 			/* select alternate font, Label Command */

fprintf(prn,"PU15,50");					/* pen up 15,50 */

fprintf(prn,"SI2,-2"					/* absolute char. size */
			"SL0.364"					/* character slant (tan20=0.36) */
			"LBMirror~;"); 				/* Label Command */

fprintf(prn,"\33%0A");  				/* enter PCL mode at previous CAP */

fprintf(prn,"\33*p3000Y");				/* vertical cursor position */

description();

fprintf(prn,"\f");						/* formfeed */

}    /* Ending of the Main Program */

description()
{
fprintf(prn,"\33(s1p12v1s0b4101T");		/* select 60 pt CG Times Italic */

fprintf(prn,"HP-GL/2 Labels (absolute sizing)\n\r"
			"The HP-GL/2 Labels "
			"are accessed from "
			"the internally resident "
			"CG Times Italic typeface.");
}