/****************************************************************/
/* patterns.c			                    			  		*/
/*                                                              */
/* patterned fonts on a black rule background using print model	*/
/* (CG times shadowed in landscape mode)						*/
/* 						        		    				    */
/* Date : 9-27-89								                */
/****************************************************************/

#include <stdio.h>
#include <fcntl.h>

int description();

FILE *prn;

main()

{ /* beginning of main program */

/* initialization section */

int point_size=200, i,
	shading, count=1, xoffset, yoffset;

prn = fopen("lpt1","wb");   				/* open lpt1 for writing */

/* printer initialization */

fprintf(prn,"\33E");         				/* send an esc E to reset printer */

fprintf(prn,"\33&l1O");         			/* enable landscape mode */

fprintf(prn,"\33&a10L");         			/* set left margin */

fprintf(prn,"\33*p200x225Y");  				/* set cursor position */

fprintf(prn,"\33*c3000a1200B");  			/* set rule size in dots */

fprintf(prn,"\33*c0P");  					/* print rule */

/* landscape printout */

fprintf(prn,"\33*p240x1200Y");  			/* set cursor position */

fprintf(prn,"\33*v0n1O");					/* source = transp, pattern = opaque */

fprintf(prn,"\33(s1p%dv1s3b5T"
			,point_size);  					/* font select by attribute */

fprintf(prn,"\33*c6G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select solid white pattern */

fprintf(prn,"P");

fprintf(prn,"\33*c5G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select HP pattern */

fprintf(prn,"a");

fprintf(prn,"\33*c4G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select HP pattern */

fprintf(prn,"t");

fprintf(prn,"\33*c3G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select HP pattern */

fprintf(prn,"t");

fprintf(prn,"\33*c2G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select HP pattern */

fprintf(prn,"e");

fprintf(prn,"\33*c1G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select HP pattern */

fprintf(prn,"r");

fprintf(prn,"\33*c6G");						/* select % shading */

fprintf(prn,"\33*v3T");						/* select HP shading pattern */

fprintf(prn,"n");

fprintf(prn,"\33*c5G");						/* select pattern */

fprintf(prn,"\33*v3T");						/* select solid white pattern */

fprintf(prn,"s");

fprintf(prn,"\r\33*p1800Y");				/* cursor position */

fprintf(prn,"\33*c100G",shading);			/* select % shading */

fprintf(prn,"\33*v2T");						/* select HP shading pattern */

fprintf(prn,"\r\33*p1800Y");				/* cursor position */

fprintf(prn,"\33*c100G",shading);			/* select % shading */

fprintf(prn,"\33*v2T");						/* select HP shading pattern */

description();

fprintf(prn,"\f");							/* formfeed */

}

description()
{
fprintf(prn,"\33(s1p12v1s0b4101T");			/* select 12 pt CG Times Italic */

fprintf(prn,"Patterned fonts on a "
			"black rule background.\n\n\r"
			"- Patterned CG Times\n\r"
			"- Opaque Pattern Transparency");
}